package eu.jonahbauer.wizard.core.messages.observer;

import eu.jonahbauer.wizard.core.model.Card;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.jetbrains.annotations.NotNull;

import java.util.UUID;

/**
 * A {@link CardMessage} is sent whenever a player plays a card.
 */
@Getter
@RequiredArgsConstructor
public final class CardMessage extends ObserverMessage {
    /**
     * The UUID of the player.
     */
    private final @NotNull UUID player;
    /**
     * The card played.
     */
    private final @NotNull Card card;
}
