package eu.jonahbauer.wizard.core.messages.observer;

import eu.jonahbauer.wizard.core.machine.Game;
import eu.jonahbauer.wizard.core.machine.states.GameState;
import lombok.Getter;

import java.util.Locale;

/**
 * A {@link StateMessage} is sent whenever the {@link Game} changes its internal {@link GameState}.
 */
@Getter
public final class StateMessage extends ObserverMessage {
    /**
     * The name of the new state in snake_case.
     */
    private final String state;

    public StateMessage(Class<? extends GameState> state) {
        if (state == null) {
            this.state = "null";
        } else {
            this.state = state.getSimpleName().replaceAll("([a-z])([A-Z]+)", "$1_$2").toLowerCase(Locale.ROOT);
        }
    }
}
