package eu.jonahbauer.wizard.core.messages.observer;

import eu.jonahbauer.wizard.core.model.Card;
import lombok.Getter;

import java.util.List;
import java.util.UUID;

/**
 * A {@link TrickMessage} is sent when a trick is completed. It contains the player who won the trick and a list of the
 * cards played.
 */
@Getter
public final class TrickMessage extends ObserverMessage {
    /**
     * The UUID of the player who won the trick.
     */
    private final UUID player;
    /**
     * The cards played.
     */
    private final List<Card> cards;

    public TrickMessage(UUID player, List<Card> cards) {
        this.player = player;
        this.cards = List.copyOf(cards);
    }
}
