package eu.jonahbauer.wizard.core.messages.player;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import eu.jonahbauer.wizard.core.util.SealedClassTypeAdapterFactory;

public abstract sealed class PlayerMessage permits PickTrumpMessage, PlayCardMessage, PredictMessage {
    public static final Gson GSON = new GsonBuilder()
            .registerTypeAdapterFactory(SealedClassTypeAdapterFactory.of(PlayerMessage.class, "Message"))
            .create();

    @Override
    public String toString() {
        return GSON.toJson(this);
    }
}
