package eu.jonahbauer.wizard.core.model;

import lombok.Getter;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

@Getter
public enum Card {
    HIDDEN(0, Suit.NONE, Suit.NONE),
    RED_JESTER(0, Suit.JESTER, Suit.NONE),
    RED_1(1, Suit.RED, Suit.RED),
    RED_2(2, Suit.RED, Suit.RED),
    RED_3(3, Suit.RED, Suit.RED),
    RED_4(4, Suit.RED, Suit.RED),
    RED_5(5, Suit.RED, Suit.RED),
    RED_6(6, Suit.RED, Suit.RED),
    RED_7(7, Suit.RED, Suit.RED),
    RED_8(8, Suit.RED, Suit.RED),
    RED_9(9, Suit.RED, Suit.RED),
    RED_10(10, Suit.RED, Suit.RED),
    RED_11(11, Suit.RED, Suit.RED),
    RED_12(12, Suit.RED, Suit.RED),
    RED_13(13, Suit.RED, Suit.RED),
    RED_WIZARD(14, Suit.WIZARD, null),
    YELLOW_JESTER(0, Suit.JESTER, Suit.NONE),
    YELLOW_1(1, Suit.YELLOW, Suit.YELLOW),
    YELLOW_2(2, Suit.YELLOW, Suit.YELLOW),
    YELLOW_3(3, Suit.YELLOW, Suit.YELLOW),
    YELLOW_4(4, Suit.YELLOW, Suit.YELLOW),
    YELLOW_5(5, Suit.YELLOW, Suit.YELLOW),
    YELLOW_6(6, Suit.YELLOW, Suit.YELLOW),
    YELLOW_7(7, Suit.YELLOW, Suit.YELLOW),
    YELLOW_8(8, Suit.YELLOW, Suit.YELLOW),
    YELLOW_9(9, Suit.YELLOW, Suit.YELLOW),
    YELLOW_10(10, Suit.YELLOW, Suit.YELLOW),
    YELLOW_11(11, Suit.YELLOW, Suit.YELLOW),
    YELLOW_12(12, Suit.YELLOW, Suit.YELLOW),
    YELLOW_13(13, Suit.YELLOW, Suit.YELLOW),
    YELLOW_WIZARD(14, Suit.WIZARD, null),
    GREEN_JESTER(0, Suit.JESTER, Suit.NONE),
    GREEN_1(1, Suit.GREEN, Suit.GREEN),
    GREEN_2(2, Suit.GREEN, Suit.GREEN),
    GREEN_3(3, Suit.GREEN, Suit.GREEN),
    GREEN_4(4, Suit.GREEN, Suit.GREEN),
    GREEN_5(5, Suit.GREEN, Suit.GREEN),
    GREEN_6(6, Suit.GREEN, Suit.GREEN),
    GREEN_7(7, Suit.GREEN, Suit.GREEN),
    GREEN_8(8, Suit.GREEN, Suit.GREEN),
    GREEN_9(9, Suit.GREEN, Suit.GREEN),
    GREEN_10(10, Suit.GREEN, Suit.GREEN),
    GREEN_11(11, Suit.GREEN, Suit.GREEN),
    GREEN_12(12, Suit.GREEN, Suit.GREEN),
    GREEN_13(13, Suit.GREEN, Suit.GREEN),
    GREEN_WIZARD(14, Suit.WIZARD, null),
    BLUE_JESTER(0, Suit.JESTER, Suit.NONE),
    BLUE_1(1, Suit.BLUE, Suit.BLUE),
    BLUE_2(2, Suit.BLUE, Suit.BLUE),
    BLUE_3(3, Suit.BLUE, Suit.BLUE),
    BLUE_4(4, Suit.BLUE, Suit.BLUE),
    BLUE_5(5, Suit.BLUE, Suit.BLUE),
    BLUE_6(6, Suit.BLUE, Suit.BLUE),
    BLUE_7(7, Suit.BLUE, Suit.BLUE),
    BLUE_8(8, Suit.BLUE, Suit.BLUE),
    BLUE_9(9, Suit.BLUE, Suit.BLUE),
    BLUE_10(10, Suit.BLUE, Suit.BLUE),
    BLUE_11(11, Suit.BLUE, Suit.BLUE),
    BLUE_12(12, Suit.BLUE, Suit.BLUE),
    BLUE_13(13, Suit.BLUE, Suit.BLUE),
    BLUE_WIZARD(14, Suit.WIZARD, null);
    
    private final int value;
    private final @NotNull Suit suit;
    private final @Nullable Suit trumpSuit;

    Card(int value, @NotNull Suit suit, @Nullable Suit trumpSuit) {
        if (trumpSuit != null && !trumpSuit.isColor()) throw new IllegalArgumentException();
        this.value = value;
        this.suit = suit;
        this.trumpSuit = trumpSuit;
    }

    @Getter
    public enum Suit {
        NONE(true),
        YELLOW(true),
        RED(true),
        GREEN(true),
        BLUE(true),
        JESTER(false),
        WIZARD(false);
        
        private final boolean color;

        Suit(boolean color) {
            this.color = color;
        }
    }
}
