package eu.jonahbauer.wizard.core.machine.states.round;

import org.junit.jupiter.api.Test;

import java.util.List;
import java.util.Map;
import java.util.UUID;

import static eu.jonahbauer.wizard.core.machine.states.GameData.*;
import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

public class FinishingRoundTest {
    @Test
    public void getPoints() {
        UUID player0 = new UUID(0, 0);
        UUID player1 = new UUID(0, 1);
        UUID player2 = new UUID(0, 2);

        List<UUID> players = List.of(
                player0,
                player1,
                player2
        );

        Map<UUID, Integer> predictions = Map.of(
                player0, 0,
                player1, 3,
                player2, 3
        );

        Map<UUID, Integer> tricks = Map.of(
                player0, 0,
                player1, 3,
                player2, 5
        );

        FinishingRound state = mock(FinishingRound.class);
        when(state.getPoints()).thenCallRealMethod();
        when(state.get(PREDICTIONS)).thenReturn(predictions);
        when(state.get(TRICKS)).thenReturn(tricks);
        when(state.get(PLAYERS)).thenReturn(players);

        assertEquals(Map.of(
                player0, 20,
                player1, 50,
                player2, -20
        ), state.getPoints());
    }
}
